/* 
 *  gstalker stock charter
 * 
 *  Copyright (c) 1998 Stefan S. Stratigakos
 * 
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, 
 *  USA.
 */

#include "myheader.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <dirent.h>

/****************************************************************************************/
void yes_delete_chart()
{
	extern GtkWidget *workwith_charts_clist;
	extern char *global_string;
	extern exit_yesno_window();
	extern int global_int;
	
	
	unlink(global_string);
	gtk_clist_remove(GTK_CLIST(workwith_charts_clist), global_int);
	exit_yesno_window();
}
/*****************************************************************************************/
void delete_chart()
{
	GList *list;
	int tint;
	gchar *tstringpointer, tstring[250];
    	extern GtkWidget *workwith_charts_clist, *yesno_window;
    	extern display_message(), exit_yesno_window();
    	extern char *error_message, *datapath, *error_message, *global_string, nothing_selected[];
    	GtkWidget *hbox, *vbox, *label, *button, *button2, *hsep;
	extern int yesno_flag, global_int;
    	

    	list = GTK_CLIST (workwith_charts_clist)->selection;
    	if (! list)
    	{
    		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	global_int = tint;
	gtk_clist_get_text(GTK_CLIST(workwith_charts_clist), tint, 0, &tstringpointer);  
	strcpy(tstring, datapath);
	strcat(tstring, tstringpointer);
	if (global_string != NULL)
  		free(global_string);
  	global_string = (char *)malloc(sizeof(tstring) + 1);
	strcpy(global_string, tstring);
	
	yesno_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_signal_connect (GTK_OBJECT (yesno_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
	gtk_window_position(GTK_WINDOW (yesno_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (yesno_window), " ");
	gtk_widget_set_usize(GTK_WIDGET (yesno_window), 300, 0);
	
	
	vbox = gtk_vbox_new (FALSE, 10);
	gtk_container_add (GTK_CONTAINER (yesno_window), vbox);
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_widget_show (vbox);
      	
      	strcpy(tstring, "Are you sure you want to delete ");
      	strcat(tstring, tstringpointer);
      	strcat(tstring, " ?");
	label = gtk_label_new(tstring);
	gtk_box_pack_start (GTK_BOX (vbox), label, FALSE, TRUE, 10);
        gtk_widget_show(label);
        
        hsep = gtk_hseparator_new();
	gtk_box_pack_start (GTK_BOX (vbox), hsep, FALSE, TRUE, 0);
        gtk_widget_show(hsep);
        
        hbox = gtk_hbutton_box_new();
        gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_box_pack_start (GTK_BOX (vbox), hbox, FALSE, TRUE, 0);
      	gtk_hbutton_box_set_spacing_default(10);
        gtk_hbutton_box_set_layout_default(GTK_BUTTONBOX_END);
      	gtk_widget_show(hbox);
        
      	button = gtk_button_new_with_label("Yes");
      	gtk_box_pack_start (GTK_BOX (hbox), button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button), "clicked",
			    GTK_SIGNAL_FUNC (yes_delete_chart), NULL);
      	gtk_widget_show (button);
      	
      	button2 = gtk_button_new_with_label("No");
      	gtk_box_pack_start (GTK_BOX (hbox), button2, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (button2), "clicked",
			    GTK_SIGNAL_FUNC (exit_yesno_window), NULL);
      	gtk_widget_show (button2);
      	
      	GTK_WIDGET_SET_FLAGS (button2, GTK_CAN_DEFAULT);
      	gtk_widget_grab_default (button2);
      	yesno_flag = 1;
      	gtk_widget_show(yesno_window);
	
}
/***********************************************************************************/
void ok_open_chart()
{
	GList *list;
	int tint;
	gchar *tstringpointer, tstring[250];
    	extern char *global_string, *error_message, nothing_selected[];
    	extern int open_file_flag;
    	extern load_file(), display_message(), exit_workwith_charts_window();
    	extern GtkWidget *workwith_charts_clist;
    	

    	list = GTK_CLIST (workwith_charts_clist)->selection;
    	if (! list)
    	{
    		error_message = nothing_selected;
		display_message();
		return;
	}
	tint = (int) list->data;
	gtk_clist_get_text (GTK_CLIST (workwith_charts_clist), tint, 0, &tstringpointer);
	if (global_string != NULL)
		free(global_string);
	strcpy(tstring, tstringpointer);
	global_string = (char *)malloc(sizeof(tstring) + 1);
	strcpy(global_string, tstring);
	open_file_flag = 1;
    	load_file();
    	exit_workwith_charts_window();
}
/****************************************************************************************/
void workwith_charts()
{
	struct dirent **dirlist;
	int tint, tint2;
	FILE *infile;
	gchar tstring[250], tstring2[250], tstring3[250], *line[4];
	char *text[] = {"Symbol", "Name", "Start", "End"}, tstring4[15], tstring5[15];
	unsigned long tlong, records;
	GtkWidget *vbox, *hbox, *open_button, *edit_button, *delete_button, *cancel_button;
	GtkWidget *help_button;
	extern GtkWidget *workwith_charts_window, *workwith_charts_clist;
    	extern exit_workwith_charts_window(), edit_chart_data(), ok_edit_indicators();
    	extern set_alerts(), ok_delete_chart(), help_workwith_charts_window(), display_message();
    	extern int workwith_charts_flag, workwith_groups_flag;
    	extern char *datapath, data_missing[], *error_message;
    	
	if (workwith_charts_flag)
		return;
	if (workwith_groups_flag)
		return;
		
	workwith_charts_window = gtk_window_new(GTK_WINDOW_DIALOG);
	gtk_signal_connect (GTK_OBJECT (workwith_charts_window), "delete_event",
			    GTK_SIGNAL_FUNC (exit_workwith_charts_window), NULL);
	gtk_signal_connect (GTK_OBJECT (workwith_charts_window), "destroy",
			    GTK_SIGNAL_FUNC (exit_workwith_charts_window), NULL);
	gtk_window_position(GTK_WINDOW (workwith_charts_window), GTK_WIN_POS_CENTER);
	gtk_window_set_title (GTK_WINDOW (workwith_charts_window), "Work With Charts");
	gtk_container_border_width (GTK_CONTAINER (workwith_charts_window), 0);
	
	hbox = gtk_hbox_new (FALSE, 10);
      	gtk_container_border_width (GTK_CONTAINER (hbox), 10);
      	gtk_container_add (GTK_CONTAINER (workwith_charts_window), hbox);
      	gtk_widget_show (hbox);
      	
      	workwith_charts_clist = gtk_clist_new_with_titles (4, text);
      	gtk_clist_set_column_width(GTK_CLIST(workwith_charts_clist), 0, 70);
      	gtk_clist_set_column_width(GTK_CLIST(workwith_charts_clist), 1, 200);
      	gtk_clist_set_column_width(GTK_CLIST(workwith_charts_clist), 2, 70);
      	gtk_clist_set_column_width(GTK_CLIST(workwith_charts_clist), 3, 70);
      	gtk_clist_set_selection_mode (GTK_CLIST (workwith_charts_clist), GTK_SELECTION_SINGLE);
       	gtk_clist_set_policy(GTK_CLIST(workwith_charts_clist),GTK_POLICY_AUTOMATIC,GTK_POLICY_AUTOMATIC);
      	gtk_container_add (GTK_CONTAINER (hbox), workwith_charts_clist);
      	gtk_container_border_width (GTK_CONTAINER (workwith_charts_clist), 0);
      	gtk_widget_set_usize(GTK_WIDGET (workwith_charts_clist), 465, 0);
      	gtk_widget_show (workwith_charts_clist);
      	
      	vbox = gtk_vbutton_box_new();
      	gtk_container_border_width (GTK_CONTAINER (vbox), 0);
      	gtk_box_pack_start (GTK_BOX (hbox), vbox, FALSE, TRUE, 0);
      	gtk_vbutton_box_set_spacing_default(5);
        gtk_vbutton_box_set_layout_default(GTK_BUTTONBOX_START);
      	gtk_widget_show (vbox);
      	
      	open_button = gtk_button_new_with_label("Open");
      	gtk_box_pack_start (GTK_BOX (vbox), open_button, FALSE, TRUE, 0);
	gtk_signal_connect (GTK_OBJECT (open_button), "clicked",
		    	    GTK_SIGNAL_FUNC (ok_open_chart), NULL);
	gtk_widget_show (open_button);
	
      	edit_button = gtk_button_new_with_label("Edit");
      	gtk_box_pack_start (GTK_BOX (vbox), edit_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (edit_button), "clicked",
			    GTK_SIGNAL_FUNC (edit_chart_data), NULL);
	gtk_widget_show (edit_button);
	
      	delete_button = gtk_button_new_with_label("Delete");
      	gtk_box_pack_start (GTK_BOX (vbox), delete_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (delete_button), "clicked",
			    GTK_SIGNAL_FUNC (delete_chart), NULL);
	gtk_widget_show (delete_button);
	
      	cancel_button = gtk_button_new_with_label("Cancel");
      	gtk_box_pack_start (GTK_BOX (vbox), cancel_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (cancel_button), "clicked",
			    GTK_SIGNAL_FUNC (exit_workwith_charts_window), NULL);
      	gtk_widget_show (cancel_button);
      	
      	help_button = gtk_button_new_with_label("Help");
      	gtk_box_pack_start (GTK_BOX (vbox), help_button, FALSE, TRUE, 0);
      	gtk_signal_connect (GTK_OBJECT (help_button), "clicked",
			    GTK_SIGNAL_FUNC (help_workwith_charts_window), NULL);
      	gtk_widget_show (help_button);
      	
   	gtk_clist_freeze (GTK_CLIST (workwith_charts_clist));
   	tint = scandir(datapath, &dirlist, NULL, alphasort);
	if (tint < 0)
    	{
    		error_message = data_missing;
    		display_message();
    		return;
    	}
	tint2 = tint;
	for (tint = 2; tint < tint2; tint++)
	{
		strcpy(tstring, datapath);
		strcat(tstring, dirlist[tint]->d_name);
   		infile = fopen(tstring, "rb");
   		if (infile)
   		{
   			fread(&tstring, NAME_SIZE, 1, infile);
			line[1] = tstring;
			fread(&tstring2, SYMBOL_SIZE, 1, infile);
			line[0] = tstring2;
			fseek(infile, HEADERSIZE, SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile);
			sprintf(tstring5, "%ld", tlong);
			tstring3[0] = tstring5[4];
			tstring3[1] = tstring5[5];
			tstring3[2] = '/';
			tstring3[3] = tstring5[6];
			tstring3[4] = tstring5[7];
			tstring3[5] = '/';
			tstring3[6] = tstring5[0];
			tstring3[7] = tstring5[1];
			tstring3[8] = tstring5[2];
			tstring3[9] = tstring5[3];
			tstring3[10] = 0;
			line[2] = tstring3;
			fseek(infile, 0L, SEEK_END);
			tlong = ftell(infile);
			tlong = tlong - HEADERSIZE;
			records = tlong / RECORDSIZE;
			fseek(infile, (long)(((records - 1) * RECORDSIZE) + HEADERSIZE),SEEK_SET);
			fread(&tlong, sizeof(unsigned long), 1, infile);
			sprintf(tstring5, "%ld", tlong);
			tstring4[0] = tstring5[4];
			tstring4[1] = tstring5[5];
			tstring4[2] = '/';
			tstring4[3] = tstring5[6];
			tstring4[4] = tstring5[7];
			tstring4[5] = '/';
			tstring4[6] = tstring5[0];
			tstring4[7] = tstring5[1];
			tstring4[8] = tstring5[2];
			tstring4[9] = tstring5[3];
			tstring4[10] = 0;
			line[3] = tstring4;
			gtk_clist_append (GTK_CLIST (workwith_charts_clist), line);
			fclose(infile);
		}
   	}
	gtk_clist_thaw (GTK_CLIST (workwith_charts_clist));
      	
      	workwith_charts_flag = 1;
      	gtk_widget_show(workwith_charts_window);
}